#!/usr/bin/env python
# -*- coding: utf-8  -*-
################################################################################
#
#  Rattail -- Retail Software Framework
#  Copyright © 2010-2012 Lance Edgar
#
#  This file is part of Rattail.
#
#  Rattail is free software: you can redistribute it and/or modify it under the
#  terms of the GNU Affero General Public License as published by the Free
#  Software Foundation, either version 3 of the License, or (at your option)
#  any later version.
#
#  Rattail is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for
#  more details.
#
#  You should have received a copy of the GNU Affero General Public License
#  along with Rattail.  If not, see <http://www.gnu.org/licenses/>.
#
################################################################################

"""
``rattail.pyramid.forms.renderers.users`` -- User Field Renderers
"""

from formalchemy.fields import TextFieldRenderer


__all__ = ['UserFieldRenderer']


class UserFieldRenderer(TextFieldRenderer):
    """
    Renderer for fields which represent ``User`` instances.
    """

    def render_readonly(self, **kwargs):
        user = self.raw_value
        if user is None:
            return u''
        return unicode(user.display_name)
